/*
 * Copyright (c) 2023 Amengine cooperation.
 *
 */

#include <nrfx_timer.h>
#include <zephyr/logging/log.h>
#include <zephyr/sys/printk.h>
#include "error.h"

LOG_MODULE_REGISTER(timer);

#define TIMER_INSTANCE_BUTTON     0

static const nrfx_timer_t _gButtonTimer = NRFX_TIMER_INSTANCE(TIMER_INSTANCE_BUTTON);

static void _timerHandlerButton(nrf_timer_event_t eventType, void * pContext) {
    LOG_INF("timer handler for button\n");
}

int timerButtonInit(void) {
    nrfx_err_t errCode;
    nrfx_timer_config_t timerCfg = {
        .frequency = NRF_TIMER_FREQ_125kHz,
        .mode      = NRF_TIMER_MODE_TIMER,
        .bit_width = NRF_TIMER_BIT_WIDTH_16,
    };

    errCode = nrfx_timer_init(&_gButtonTimer, &timerCfg, _timerHandlerButton);
    if (errCode != NRFX_SUCCESS) {
        printk("nrfx_timer_init failed with: %d\n", errCode);
        return -EAGAIN;
    }

    return 0;
}
